//
//  ViewController.m
//  ReflexesTester
//
//  Created by 平井 祐樹 on 12/07/16.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController

@synthesize touchView   = _touchView;
@synthesize statusLabel = _statusLabel;
@synthesize startButton = _startButton;

#pragma mark - UIViewControllerクラスのメソッド

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // 初期表示時のラベルをセット
    self.statusLabel.text = @"スタートボタンを押してね!!";
}

- (void)viewDidUnload
{
    _startDate = nil;
    [self setTouchView:nil];
    [self setStatusLabel:nil];
    [self setStartButton:nil];
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // UIInterfaceOrientationPortraitで固定
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - 独自のメソッド

- (IBAction)startButtonPressed:(id)sender
{
    self.statusLabel.text = @"Ready...";
    // ゲーム開始ボタンを無効化
    self.startButton.enabled = NO;

    // 1〜10秒後にprepareメソッドを実行する
    NSInteger interval = (rand() % 10) + 1;
    [NSTimer scheduledTimerWithTimeInterval:interval
                                     target:self
                                   selector:@selector(prepare) 
                                   userInfo:nil
                                    repeats:NO];
}

- (void)prepare
{
    // 表示する矩形の数を1から5の中からランダムで決定する
    NSInteger count = (rand() % 5) + 1;
    [self.touchView prepare:count];
}

- (void)start
{
    self.statusLabel.text = @"Go!!";
    // ゲーム開始時刻をセット
    _startDate = [NSDate date];
}

- (void)finish
{
    // ゲーム開始時刻から現在時刻までの経過時間を取得
    NSTimeInterval interval = [[NSDate date] timeIntervalSinceDate:_startDate];
    
    self.statusLabel.text = [NSString stringWithFormat:@"%.2f秒でクリアしました！", interval];

    // ゲームが終了したので、ゲーム開始ボタンを有効化
    self.startButton.enabled = YES;
}

@end
